Index: /NEMO/branches/2019/dev_r11756_grid_definitions/cfgs/AGRIF_DEMO/EXPREF/context_nemo.xml
===================================================================
--- /NEMO/branches/2019/dev_r11756_grid_definitions/cfgs/AGRIF_DEMO/EXPREF/context_nemo.xml	(revision 11809)
+++ /NEMO/branches/2019/dev_r11756_grid_definitions/cfgs/AGRIF_DEMO/EXPREF/context_nemo.xml	(revision 11810)
@@ -39,4 +39,7 @@
       <axis id="iax_20C" long_name="20 degC isotherm"   unit="degC"              />
       <axis id="iax_28C" long_name="28 degC isotherm"   unit="degC"              />
+      <axis id="deptht_surface" axis_ref="deptht" >
+         <zoom_axis begin=" 1 " n=" 1 " />
+      </axis>
     </axis_definition>
  
Index: /NEMO/branches/2019/dev_r11756_grid_definitions/cfgs/AMM12/EXPREF/context_nemo.xml
===================================================================
--- /NEMO/branches/2019/dev_r11756_grid_definitions/cfgs/AMM12/EXPREF/context_nemo.xml	(revision 11809)
+++ /NEMO/branches/2019/dev_r11756_grid_definitions/cfgs/AMM12/EXPREF/context_nemo.xml	(revision 11810)
@@ -37,4 +37,7 @@
       <axis id="iax_20C" long_name="20 degC isotherm"  unit="degC"              />
       <axis id="iax_28C" long_name="28 degC isotherm"  unit="degC"              />
+      <axis id="deptht_surface" axis_ref="deptht" >
+         <zoom_axis begin=" 1 " n=" 1 " />
+      </axis>
     </axis_definition>
  
Index: /NEMO/branches/2019/dev_r11756_grid_definitions/cfgs/C1D_PAPA/EXPREF/context_nemo.xml
===================================================================
--- /NEMO/branches/2019/dev_r11756_grid_definitions/cfgs/C1D_PAPA/EXPREF/context_nemo.xml	(revision 11809)
+++ /NEMO/branches/2019/dev_r11756_grid_definitions/cfgs/C1D_PAPA/EXPREF/context_nemo.xml	(revision 11810)
@@ -27,4 +27,7 @@
       <axis id="iax_20C" long_name="20 degC isotherm"   unit="degC"            />
       <axis id="iax_28C" long_name="28 degC isotherm"   unit="degC"            />
+      <axis id="deptht_surface" axis_ref="deptht" >
+         <zoom_axis begin=" 1 " n=" 1 " />
+      </axis>
     </axis_definition>
  
Index: /NEMO/branches/2019/dev_r11756_grid_definitions/cfgs/GYRE_BFM/EXPREF/context_nemo.xml
===================================================================
--- /NEMO/branches/2019/dev_r11756_grid_definitions/cfgs/GYRE_BFM/EXPREF/context_nemo.xml	(revision 11809)
+++ /NEMO/branches/2019/dev_r11756_grid_definitions/cfgs/GYRE_BFM/EXPREF/context_nemo.xml	(revision 11810)
@@ -38,4 +38,7 @@
       <axis id="iax_20C" long_name="20 degC isotherm"  unit="degC"              />
       <axis id="iax_28C" long_name="28 degC isotherm"  unit="degC"              />
+      <axis id="deptht_surface" axis_ref="deptht" >
+         <zoom_axis begin=" 1 " n=" 1 " />
+      </axis>
     </axis_definition>
  
Index: /NEMO/branches/2019/dev_r11756_grid_definitions/cfgs/GYRE_PISCES/EXPREF/context_nemo.xml
===================================================================
--- /NEMO/branches/2019/dev_r11756_grid_definitions/cfgs/GYRE_PISCES/EXPREF/context_nemo.xml	(revision 11809)
+++ /NEMO/branches/2019/dev_r11756_grid_definitions/cfgs/GYRE_PISCES/EXPREF/context_nemo.xml	(revision 11810)
@@ -38,4 +38,7 @@
       <axis id="iax_20C" long_name="20 degC isotherm"  unit="degC"              />
       <axis id="iax_28C" long_name="28 degC isotherm"  unit="degC"              />
+      <axis id="deptht_surface" axis_ref="deptht" >
+         <zoom_axis begin=" 1 " n=" 1 " />
+      </axis>
     </axis_definition>
  
Index: /NEMO/branches/2019/dev_r11756_grid_definitions/cfgs/ORCA2_ICE_PISCES/EXPREF/context_nemo.xml
===================================================================
--- /NEMO/branches/2019/dev_r11756_grid_definitions/cfgs/ORCA2_ICE_PISCES/EXPREF/context_nemo.xml	(revision 11809)
+++ /NEMO/branches/2019/dev_r11756_grid_definitions/cfgs/ORCA2_ICE_PISCES/EXPREF/context_nemo.xml	(revision 11810)
@@ -42,4 +42,7 @@
       <axis id="iax_20C" long_name="20 degC isotherm"  unit="degC"              />
       <axis id="iax_28C" long_name="28 degC isotherm"  unit="degC"              />
+      <axis id="deptht_surface" axis_ref="deptht" >
+         <zoom_axis begin=" 1 " n=" 1 " />
+      </axis>
     </axis_definition>
  
Index: /NEMO/branches/2019/dev_r11756_grid_definitions/cfgs/ORCA2_OFF_PISCES/EXPREF/context_nemo.xml
===================================================================
--- /NEMO/branches/2019/dev_r11756_grid_definitions/cfgs/ORCA2_OFF_PISCES/EXPREF/context_nemo.xml	(revision 11809)
+++ /NEMO/branches/2019/dev_r11756_grid_definitions/cfgs/ORCA2_OFF_PISCES/EXPREF/context_nemo.xml	(revision 11810)
@@ -39,4 +39,7 @@
       <axis id="iax_20C" long_name="20 degC isotherm"  unit="degC"              />
       <axis id="iax_28C" long_name="28 degC isotherm"  unit="degC"              />
+      <axis id="deptht_surface" axis_ref="deptht" >
+         <zoom_axis begin=" 1 " n=" 1 " />
+      </axis>
     </axis_definition>
  
Index: /NEMO/branches/2019/dev_r11756_grid_definitions/cfgs/ORCA2_OFF_TRC/EXPREF/context_nemo.xml
===================================================================
--- /NEMO/branches/2019/dev_r11756_grid_definitions/cfgs/ORCA2_OFF_TRC/EXPREF/context_nemo.xml	(revision 11809)
+++ /NEMO/branches/2019/dev_r11756_grid_definitions/cfgs/ORCA2_OFF_TRC/EXPREF/context_nemo.xml	(revision 11810)
@@ -38,4 +38,7 @@
       <axis id="iax_20C" long_name="20 degC isotherm"  unit="degC"              />
       <axis id="iax_28C" long_name="28 degC isotherm"  unit="degC"              />
+      <axis id="deptht_surface" axis_ref="deptht" >
+         <zoom_axis begin=" 1 " n=" 1 " />
+      </axis>
     </axis_definition>
  
Index: /NEMO/branches/2019/dev_r11756_grid_definitions/cfgs/ORCA2_SAS_ICE/EXPREF/context_nemo.xml
===================================================================
--- /NEMO/branches/2019/dev_r11756_grid_definitions/cfgs/ORCA2_SAS_ICE/EXPREF/context_nemo.xml	(revision 11809)
+++ /NEMO/branches/2019/dev_r11756_grid_definitions/cfgs/ORCA2_SAS_ICE/EXPREF/context_nemo.xml	(revision 11810)
@@ -39,4 +39,7 @@
       <axis id="iax_20C" long_name="20 degC isotherm"   unit="degC"              />
       <axis id="iax_28C" long_name="28 degC isotherm"   unit="degC"              />
+      <axis id="deptht_surface" axis_ref="deptht" >
+         <zoom_axis begin=" 1 " n=" 1 " />
+      </axis>
     </axis_definition>
  
Index: /NEMO/branches/2019/dev_r11756_grid_definitions/cfgs/SHARED/domain_def_nemo.xml
===================================================================
--- /NEMO/branches/2019/dev_r11756_grid_definitions/cfgs/SHARED/domain_def_nemo.xml	(revision 11809)
+++ /NEMO/branches/2019/dev_r11756_grid_definitions/cfgs/SHARED/domain_def_nemo.xml	(revision 11810)
@@ -179,4 +179,8 @@
      <!--   zonal mean grid   -->
      <domain id="gznl" long_name="gznl"/>
+     <domain id="ptr" domain_ref="gznl" >
+         <zoom_domain id="ptr" ibegin="0000" jbegin="0" ni="1" nj="0000" />
+     </domain>
+
      <domain id="znl_T" domain_ref="gznl" > <zoom_domain id="znl_T"/> </domain>
      <domain id="znl_W" domain_ref="gznl" > <zoom_domain id="znl_W"/> </domain>
Index: /NEMO/branches/2019/dev_r11756_grid_definitions/cfgs/SHARED/grid_def_nemo.xml
===================================================================
--- /NEMO/branches/2019/dev_r11756_grid_definitions/cfgs/SHARED/grid_def_nemo.xml	(revision 11809)
+++ /NEMO/branches/2019/dev_r11756_grid_definitions/cfgs/SHARED/grid_def_nemo.xml	(revision 11810)
@@ -1,3 +1,2 @@
-
     <grid_definition>    
 
@@ -57,5 +56,24 @@
         <scalar/>
       </grid>
+        <!--  -->
+       <grid id="grid_T_SFC">
+         <domain id="grid_T" />
+         <axis   axis_ref="deptht_surface" />
+       </grid>
+        <!--  -->
+       <grid id="gznl_T_2D">
+         <domain id="ptr" />
+       </grid>
+        <!--  -->
+       <grid id="gznl_T_3D">
+         <domain id="ptr" />
+         <axis axis_ref="deptht" />
+       </grid>
+        <!--  -->
+       <grid id="gznl_W_3D">
+         <domain id="ptr" />
+         <axis axis_ref="depthw" />
+       </grid>
+
 
     </grid_definition>
-    
Index: /NEMO/branches/2019/dev_r11756_grid_definitions/cfgs/SPITZ12/EXPREF/context_nemo.xml
===================================================================
--- /NEMO/branches/2019/dev_r11756_grid_definitions/cfgs/SPITZ12/EXPREF/context_nemo.xml	(revision 11809)
+++ /NEMO/branches/2019/dev_r11756_grid_definitions/cfgs/SPITZ12/EXPREF/context_nemo.xml	(revision 11810)
@@ -39,4 +39,7 @@
       <axis id="iax_20C" long_name="20 degC isotherm"   unit="degC"              />
       <axis id="iax_28C" long_name="28 degC isotherm"   unit="degC"              />
+      <axis id="deptht_surface" axis_ref="deptht" >
+         <zoom_axis begin=" 1 " n=" 1 " />
+      </axis>
     </axis_definition>
  